# Monark

Monark is a database migrator and seeder, intended to supplement Active
Record's migrations and replace Rails's seed tasks.

It keeps track of which SQL or Ruby code has been run on your database so that
you can change make incremental changes to your production database without
having to run ad-hoc deployment scripts.

Why "Monark?" I wanted to call it "Monarch" but the name was taken and I
couldn't think of anything better.

## Installation

Add this line to your application's Gemfile:

    gem 'monark'

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install monark

## Usage

Read [this file](https://github.com/flexminder/monark/blob/master/lib/generators/templates/Migrations.rb) for information on how to set up Monark.

### Setup

    rails generate monark
    edit db/monark/Migrations.rb
    add migrations to db/monark

### Tasks

    # rake monark:assume_done  # Assume all migrations have been performed
    # rake monark:migrate      # Perform pending migrations
    # rake monark:reload       # Perform reloadable and pending migrations
    # rake monark:reset        # Perform all migrations again


If you're porting your seeds or other existing database management code to
Monark, you'll probably want add your existing seeds, deploy and peform `rake monark:assume_done` to make sure you don't overwrite anything in production.

Then you can safely add more migrations and deploy them with
`rake monark:migrate`.

## Deficiencies

It only works with Active Record for now, since this is what we currently need
at FlexMinder. Support for other database libraries would be nice to have but
we probably won't add that until we need it ourselves.

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request

## License

Copyright (c) 2013 Norman Clarke and Flexminder Inc.

MIT License

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
