require 'bundler/setup'
require 'minitest/autorun'
require 'ostruct'
require 'set'
require 'active_record'

$VERBOSE = true

require 'monark'

class Module
  def test(name, &block)
    define_method "test #{name}", block
  end
end

class Monark::Migration
  def puts(*args); end
end

connection_params = {
  :adapter  => 'sqlite3',
  :database => ':memory:',
  :encoding => 'utf8'
}

ActiveRecord::Base.establish_connection connection_params

module Monark
  module TestHelp
    def fixtures_path
      Pathname(File.expand_path("../fixtures", __FILE__))
    end

    def context
      @context ||= Context.new('/tmp')
    end

    def transaction
      ActiveRecord::Base.transaction { yield ; raise ActiveRecord::Rollback }
    end
  end
end