require 'helper'

module Monark
  class MigrationTest < MiniTest::Unit::TestCase

    include TestHelp

    test 'should load SQL' do
      migration = Migration.new(fixtures_path, "foo")
      assert_equal "CREATE TABLE foo (a_col INTEGER);", migration.code
    end

    test 'should load SQL + Erb' do
      begin
        Thread.current[:table] = "foo"
        migration = Migration.new(fixtures_path, "bar")
        assert_equal "INSERT INTO foo VALUES (1);", migration.code
      ensure
        Thread.current[:table] = nil
      end
    end

    test 'should load Ruby' do
      migration = Migration.new(fixtures_path, "baz")
      assert_equal %q{Thread.current[:hello] = 'world'}, migration.code
    end

    test 'should load a proc' do
      migration = Migration.new(fixtures_path, "say hello", -> {puts 'hello world'})
      assert_kind_of Proc, migration.code
    end

  end
end